package validators

import (
	"fmt"

	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/schema"
)

func DivisibleBy(divisibility int) schema.SchemaValidateFunc {
	return func(i interface{}, k string) (warnings []string, errors []error) {
		total, ok := i.(int)
		if !ok {
			errors = append(errors, fmt.Errorf("expected type of %s to be integer", k))
			return warnings, errors
		}
		if total%divisibility != 0 {
			errors = append(errors, fmt.Errorf("expected value of %s to be divisible by %d", k, divisibility))
		}

		return warnings, errors
	}
}
